/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PRODNCMP                                                 */
/* Tabela : PRODNCMP                                                          */
/*                                                                            */
/* Criao:                                                                   */
/*                                                                            */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PRODNCMP
BEFORE INSERT OR UPDATE OR DELETE
ON PRODNCMP FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPRNC := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDPRODUTO,0) <> NVL(:NEW.CDPRODUTO,0)) OR
         (NVL(:OLD.CDFILIAL,0)  <> NVL(:NEW.CDFILIAL,0)) THEN
         :NEW.DTULTATUPRNC := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PRODNCMP', :OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';CDPRODUTO='||:OLD.CDPRODUTO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PRODNCMP MODIFY DTULTATUPRNC DEFAULT SYSDATE
/
